Makefile: Add version check for iallocator.rst
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
25
26 # Note: these are automake-specific variables, and must be named after
27 # the directory + 'dir' suffix
28 clientdir = $(pkgpythondir)/client
29 hypervisordir = $(pkgpythondir)/hypervisor
30 httpdir = $(pkgpythondir)/http
31 masterddir = $(pkgpythondir)/masterd
32 confddir = $(pkgpythondir)/confd
33 rapidir = $(pkgpythondir)/rapi
34 serverdir = $(pkgpythondir)/server
35 watcherdir = $(pkgpythondir)/watcher
36 impexpddir = $(pkgpythondir)/impexpd
37 utilsdir = $(pkgpythondir)/utils
38 toolsdir = $(pkglibdir)/tools
39 iallocatorsdir = $(pkglibdir)/iallocators
40 pytoolsdir = $(pkgpythondir)/tools
41 docdir = $(datadir)/doc/$(PACKAGE)
42
43 # Delete output file if an error occurred while building it
44 .DELETE_ON_ERROR:
45
46 HTOOLS_DIRS = \
47         htools \
48         htools/Ganeti \
49         htools/Ganeti/HTools
50
51 DIRS = \
52         autotools \
53         daemons \
54         devel \
55         doc \
56         doc/examples \
57         doc/examples/hooks \
58         doc/examples/gnt-debug \
59         $(HTOOLS_DIRS) \
60         lib \
61         lib/client \
62         lib/build \
63         lib/confd \
64         lib/http \
65         lib/hypervisor \
66         lib/impexpd \
67         lib/masterd \
68         lib/rapi \
69         lib/server \
70         lib/tools \
71         lib/utils \
72         lib/watcher \
73         man \
74         qa \
75         test \
76         test/data \
77         tools
78
79 BUILDTIME_DIR_AUTOCREATE = \
80         scripts \
81         $(APIDOC_DIR) \
82         $(APIDOC_PY_DIR) \
83         $(APIDOC_HS_DIR) \
84         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
85         $(COVERAGE_DIR) \
86         $(COVERAGE_PY_DIR) \
87         $(COVERAGE_HS_DIR) \
88         .hpc
89
90 BUILDTIME_DIRS = \
91         $(BUILDTIME_DIR_AUTOCREATE) \
92         doc/html
93
94 DIRCHECK_EXCLUDE = \
95         $(BUILDTIME_DIRS) \
96         ganeti-[0-9]*.[0-9]*.[0-9]* \
97         doc/html/_*
98
99 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
100
101 # some helper vars
102 COVERAGE_DIR = doc/coverage
103 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
104 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
105 APIDOC_DIR = doc/api
106 APIDOC_PY_DIR = $(APIDOC_DIR)/py
107 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
108
109 MAINTAINERCLEANFILES = \
110         $(docpng) \
111         $(maninput) \
112         doc/install-quick.rst \
113         doc/news.rst \
114         doc/upgrade.rst \
115         vcs-version
116
117 maintainer-clean-local:
118         rm -rf $(BUILDTIME_DIRS)
119
120 CLEANFILES = \
121         $(addsuffix /*.py[co],$(DIRS)) \
122         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
123         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
124         $(all_dirfiles) \
125         $(PYTHON_BOOTSTRAP) \
126         epydoc.conf \
127         autotools/replace_vars.sed \
128         daemons/daemon-util \
129         daemons/ganeti-cleaner \
130         devel/upload \
131         doc/examples/bash_completion \
132         doc/examples/ganeti.initd \
133         doc/examples/ganeti-kvm-poweroff.initd \
134         doc/examples/ganeti.cron \
135         doc/examples/gnt-config-backup \
136         doc/examples/hooks/ipsec \
137         $(man_MANS) \
138         $(manhtml) \
139         tools/kvm-ifup \
140         stamp-srclinks \
141         $(nodist_pkgpython_PYTHON) \
142         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
143         .hpc/*.mix htools/*.tix \
144         doc/hs-lint.html
145
146 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
147 # it'll cause the target to rebuild every time.
148 BUILT_SOURCES = \
149         ganeti \
150         stamp-srclinks \
151         lib/_autoconf.py \
152         $(all_dirfiles) \
153         $(PYTHON_BOOTSTRAP)
154
155 nodist_pkgpython_PYTHON = \
156         lib/_autoconf.py
157
158 noinst_PYTHON = \
159         lib/build/__init__.py \
160         lib/build/sphinx_ext.py
161
162 pkgpython_PYTHON = \
163         lib/__init__.py \
164         lib/asyncnotifier.py \
165         lib/backend.py \
166         lib/bdev.py \
167         lib/bootstrap.py \
168         lib/cli.py \
169         lib/cmdlib.py \
170         lib/compat.py \
171         lib/config.py \
172         lib/constants.py \
173         lib/daemon.py \
174         lib/errors.py \
175         lib/ht.py \
176         lib/jqueue.py \
177         lib/jstore.py \
178         lib/locking.py \
179         lib/luxi.py \
180         lib/mcpu.py \
181         lib/netutils.py \
182         lib/objects.py \
183         lib/opcodes.py \
184         lib/qlang.py \
185         lib/query.py \
186         lib/rpc.py \
187         lib/runtime.py \
188         lib/serializer.py \
189         lib/ssconf.py \
190         lib/ssh.py \
191         lib/storage.py \
192         lib/uidpool.py \
193         lib/workerpool.py
194
195 client_PYTHON = \
196         lib/client/__init__.py \
197         lib/client/gnt_backup.py \
198         lib/client/gnt_cluster.py \
199         lib/client/gnt_debug.py \
200         lib/client/gnt_group.py \
201         lib/client/gnt_instance.py \
202         lib/client/gnt_job.py \
203         lib/client/gnt_node.py \
204         lib/client/gnt_os.py
205
206 hypervisor_PYTHON = \
207         lib/hypervisor/__init__.py \
208         lib/hypervisor/hv_base.py \
209         lib/hypervisor/hv_chroot.py \
210         lib/hypervisor/hv_fake.py \
211         lib/hypervisor/hv_kvm.py \
212         lib/hypervisor/hv_lxc.py \
213         lib/hypervisor/hv_xen.py
214
215 rapi_PYTHON = \
216         lib/rapi/__init__.py \
217         lib/rapi/baserlib.py \
218         lib/rapi/client.py \
219         lib/rapi/client_utils.py \
220         lib/rapi/connector.py \
221         lib/rapi/rlib2.py
222
223 http_PYTHON = \
224         lib/http/__init__.py \
225         lib/http/auth.py \
226         lib/http/client.py \
227         lib/http/server.py
228
229 confd_PYTHON = \
230         lib/confd/__init__.py \
231         lib/confd/client.py \
232         lib/confd/querylib.py \
233         lib/confd/server.py
234
235 masterd_PYTHON = \
236         lib/masterd/__init__.py \
237         lib/masterd/instance.py
238
239 impexpd_PYTHON = \
240         lib/impexpd/__init__.py
241
242 watcher_PYTHON = \
243         lib/watcher/__init__.py
244
245 server_PYTHON = \
246         lib/server/__init__.py \
247         lib/server/confd.py \
248         lib/server/masterd.py \
249         lib/server/noded.py \
250         lib/server/rapi.py
251
252 pytools_PYTHON = \
253         lib/tools/__init__.py \
254         lib/tools/ensure_dirs.py
255
256 utils_PYTHON = \
257         lib/utils/__init__.py \
258         lib/utils/algo.py \
259         lib/utils/filelock.py \
260         lib/utils/hash.py \
261         lib/utils/io.py \
262         lib/utils/log.py \
263         lib/utils/mlock.py \
264         lib/utils/nodesetup.py \
265         lib/utils/process.py \
266         lib/utils/retry.py \
267         lib/utils/text.py \
268         lib/utils/wrapper.py \
269         lib/utils/x509.py
270
271 docrst = \
272         doc/admin.rst \
273         doc/design-2.0.rst \
274         doc/design-2.1.rst \
275         doc/design-2.2.rst \
276         doc/design-2.3.rst \
277         doc/design-htools-2.3.rst \
278         doc/design-2.4.rst \
279         doc/design-draft.rst \
280         doc/design-oob.rst \
281         doc/design-cpu-pinning.rst \
282         doc/design-query2.rst \
283         doc/design-x509-ca.rst \
284         doc/design-http-server.rst \
285         doc/design-impexp2.rst \
286         doc/design-lu-generated-jobs.rst \
287         doc/design-multi-reloc.rst \
288         doc/cluster-merge.rst \
289         doc/design-shared-storage.rst \
290         doc/devnotes.rst \
291         doc/glossary.rst \
292         doc/hooks.rst \
293         doc/iallocator.rst \
294         doc/index.rst \
295         doc/install-quick.rst \
296         doc/install.rst \
297         doc/locking.rst \
298         doc/move-instance.rst \
299         doc/news.rst \
300         doc/rapi.rst \
301         doc/security.rst \
302         doc/upgrade.rst \
303         doc/walkthrough.rst
304
305 HS_PROGS = \
306         htools/hbal \
307         htools/hscan \
308         htools/hail \
309         htools/hspace
310
311 HS_ALL_PROGS = $(HS_PROGS) htools/test
312 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
313 # we don't add -Werror by default
314 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
315 # extra flags that can be overriden on the command line
316 HEXTRA =
317 # exclude options for coverage reports
318 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC
319
320 HS_LIB_SRCS = \
321         htools/Ganeti/HTools/CLI.hs \
322         htools/Ganeti/HTools/Cluster.hs \
323         htools/Ganeti/HTools/Container.hs \
324         htools/Ganeti/HTools/ExtLoader.hs \
325         htools/Ganeti/HTools/Group.hs \
326         htools/Ganeti/HTools/IAlloc.hs \
327         htools/Ganeti/HTools/Instance.hs \
328         htools/Ganeti/HTools/Loader.hs \
329         htools/Ganeti/HTools/Luxi.hs \
330         htools/Ganeti/HTools/Node.hs \
331         htools/Ganeti/HTools/PeerMap.hs \
332         htools/Ganeti/HTools/QC.hs \
333         htools/Ganeti/HTools/Rapi.hs \
334         htools/Ganeti/HTools/Simu.hs \
335         htools/Ganeti/HTools/Text.hs \
336         htools/Ganeti/HTools/Types.hs \
337         htools/Ganeti/HTools/Utils.hs \
338         htools/Ganeti/Jobs.hs \
339         htools/Ganeti/Luxi.hs \
340         htools/Ganeti/OpCodes.hs
341
342 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
343 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
344
345 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
346
347 # Note: we use here an order-only prerequisite, as the contents of
348 # _autoconf.py are not actually influencing the html build output: it
349 # has to exist in order for the sphinx module to be loaded
350 # successfully, but we certainly don't want the docs to be rebuilt if
351 # it changes
352 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
353         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
354         | lib/_autoconf.py
355         @test -n "$(SPHINX)" || \
356             { echo 'sphinx-build' not found during configure; exit 1; }
357         @mkdir_p@ $(dir $@)
358         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
359             -d . \
360             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
361             -D release="$(PACKAGE_VERSION)" \
362             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
363         rm -f doc/html/.buildinfo doc/html/objects.inv
364         touch $@
365
366 doc/html: doc/html/index.html
367
368 doc/install-quick.rst: INSTALL
369 doc/news.rst: NEWS
370 doc/upgrade.rst: UPGRADE
371
372 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
373         set -e; \
374         { echo '.. This file is automatically updated at build time from $<.'; \
375           echo '.. Do not edit.'; \
376           echo; \
377           cat $<; \
378         } > $@
379
380 docdot = \
381         doc/arch-2.0.dot \
382         doc/design-2.1-lock-acquire.dot \
383         doc/design-2.1-lock-release.dot
384
385 docpng = $(patsubst %.dot,%.png,$(docdot))
386
387 # Things to build but not to install (add it to EXTRA_DIST if it should be
388 # distributed)
389 noinst_DATA = \
390         devel/upload \
391         doc/html \
392         doc/examples/bash_completion \
393         doc/examples/ganeti.cron \
394         doc/examples/ganeti.initd \
395         doc/examples/ganeti-kvm-poweroff.initd \
396         doc/examples/gnt-config-backup \
397         doc/examples/hooks/ipsec \
398         $(manhtml)
399
400 gnt_scripts = \
401         scripts/gnt-backup \
402         scripts/gnt-cluster \
403         scripts/gnt-debug \
404         scripts/gnt-group \
405         scripts/gnt-instance \
406         scripts/gnt-job \
407         scripts/gnt-node \
408         scripts/gnt-os
409
410 PYTHON_BOOTSTRAP_SBIN = \
411         daemons/ganeti-confd \
412         daemons/ganeti-masterd \
413         daemons/ganeti-noded \
414         daemons/ganeti-watcher \
415         daemons/ganeti-rapi \
416         scripts/gnt-backup \
417         scripts/gnt-cluster \
418         scripts/gnt-debug \
419         scripts/gnt-group \
420         scripts/gnt-instance \
421         scripts/gnt-job \
422         scripts/gnt-node \
423         scripts/gnt-os
424
425 PYTHON_BOOTSTRAP = \
426         $(PYTHON_BOOTSTRAP_SBIN) \
427         tools/ensure-dirs
428
429 qa_scripts = \
430         qa/ganeti-qa.py \
431         qa/qa_cluster.py \
432         qa/qa_config.py \
433         qa/qa_daemon.py \
434         qa/qa_env.py \
435         qa/qa_error.py \
436         qa/qa_instance.py \
437         qa/qa_node.py \
438         qa/qa_os.py \
439         qa/qa_rapi.py \
440         qa/qa_tags.py \
441         qa/qa_utils.py
442
443 bin_SCRIPTS =
444 iallocators_SCRIPTS =
445 if WANT_HTOOLS
446 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
447 iallocators_SCRIPTS += $(filter htools/hail,$(HS_PROGS))
448 endif
449
450 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
451         @if [ -z "$(HTOOLS)" ]; then \
452           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
453           exit 1; \
454         fi
455         @BINARY=$(@:htools/%=%); \
456         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
457           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
458           exit 1; \
459         fi
460         BINARY=$(@:htools/%=%); $(GHC) --make \
461           $(HFLAGS) $(HEXTRA) $(HTOOLS_NOCURL) \
462           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
463
464 # for the htools/test binary, we need to enable profiling/coverage
465 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
466         -fno-warn-monomorphism-restriction -fno-warn-orphans \
467         -fno-warn-missing-methods -fno-warn-unused-imports
468
469 dist_sbin_SCRIPTS = \
470         tools/ganeti-listrunner
471
472 nodist_sbin_SCRIPTS = \
473         $(PYTHON_BOOTSTRAP_SBIN) \
474         daemons/ganeti-cleaner
475
476 dist_tools_SCRIPTS = \
477         tools/burnin \
478         tools/cfgshell \
479         tools/cfgupgrade \
480         tools/cfgupgrade12 \
481         tools/cluster-merge \
482         tools/lvmstrap \
483         tools/move-instance \
484         tools/setup-ssh \
485         tools/sanitize-config
486
487 pkglib_python_scripts = \
488         daemons/import-export \
489         tools/check-cert-expired
490
491 nodist_pkglib_python_scripts = \
492         tools/ensure-dirs
493
494 pkglib_SCRIPTS = \
495         daemons/daemon-util \
496         tools/kvm-ifup \
497         $(pkglib_python_scripts)
498
499 nodist_pkglib_SCRIPTS = \
500         $(nodist_pkglib_python_scripts)
501
502 EXTRA_DIST = \
503         NEWS \
504         UPGRADE \
505         epydoc.conf.in \
506         pylintrc \
507         autotools/build-bash-completion \
508         autotools/check-python-code \
509         autotools/check-man \
510         autotools/check-news \
511         autotools/check-tar \
512         autotools/check-version \
513         autotools/convert-constants \
514         autotools/docpp \
515         autotools/gen-coverage \
516         autotools/testrunner \
517         $(RUN_IN_TEMPDIR) \
518         daemons/daemon-util.in \
519         daemons/ganeti-cleaner.in \
520         $(pkglib_python_scripts) \
521         devel/upload.in \
522         tools/kvm-ifup.in \
523         $(docdot) \
524         $(docpng) \
525         $(docrst) \
526         doc/conf.py \
527         doc/html \
528         doc/examples/ganeti.initd.in \
529         doc/examples/ganeti-kvm-poweroff.initd.in \
530         doc/examples/ganeti.cron.in \
531         doc/examples/gnt-config-backup.in \
532         doc/examples/ganeti.default \
533         doc/examples/ganeti.default-debug \
534         doc/examples/hooks/ethers \
535         doc/examples/hooks/ipsec.in \
536         doc/examples/gnt-debug/README \
537         doc/examples/gnt-debug/delay0.json \
538         doc/examples/gnt-debug/delay50.json \
539         test/testutils.py \
540         test/mocks.py \
541         $(dist_TESTS) \
542         $(TEST_FILES) \
543         man/footer.rst \
544         $(manrst) \
545         $(maninput) \
546         qa/qa-sample.json \
547         $(qa_scripts) \
548         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
549         $(HS_PROG_SRCS)
550
551 man_MANS = \
552         man/ganeti.7 \
553         man/ganeti-cleaner.8 \
554         man/ganeti-confd.8 \
555         man/ganeti-listrunner.8 \
556         man/ganeti-masterd.8 \
557         man/ganeti-noded.8 \
558         man/ganeti-os-interface.7 \
559         man/ganeti-rapi.8 \
560         man/ganeti-watcher.8 \
561         man/gnt-backup.8 \
562         man/gnt-cluster.8 \
563         man/gnt-debug.8 \
564         man/gnt-group.8 \
565         man/gnt-instance.8 \
566         man/gnt-job.8 \
567         man/gnt-node.8 \
568         man/gnt-os.8 \
569         man/hail.1 \
570         man/hbal.1 \
571         man/hscan.1 \
572         man/hspace.1
573
574 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
575 manhtml = $(patsubst %.rst,%.html,$(manrst))
576 mangen = $(patsubst %.rst,%.gen,$(manrst))
577 maninput = \
578         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
579         $(patsubst %.html,%.html.in,$(manhtml)) \
580         man/footer.man man/footer.html $(mangen)
581
582 TEST_FILES = \
583         test/data/bdev-drbd-8.0.txt \
584         test/data/bdev-drbd-8.3.txt \
585         test/data/bdev-drbd-disk.txt \
586         test/data/bdev-drbd-net-ip4.txt \
587         test/data/bdev-drbd-net-ip6.txt \
588         test/data/cert1.pem \
589         test/data/proc_drbd8.txt \
590         test/data/proc_drbd80-emptyline.txt \
591         test/data/proc_drbd83.txt \
592         test/data/sys_drbd_usermode_helper.txt \
593         test/import-export_unittest-helper
594
595 python_tests = \
596         test/ganeti.asyncnotifier_unittest.py \
597         test/ganeti.backend_unittest.py \
598         test/ganeti.bdev_unittest.py \
599         test/ganeti.cli_unittest.py \
600         test/ganeti.client.gnt_cluster_unittest.py \
601         test/ganeti.client.gnt_instance_unittest.py \
602         test/ganeti.daemon_unittest.py \
603         test/ganeti.cmdlib_unittest.py \
604         test/ganeti.compat_unittest.py \
605         test/ganeti.confd.client_unittest.py \
606         test/ganeti.config_unittest.py \
607         test/ganeti.constants_unittest.py \
608         test/ganeti.errors_unittest.py \
609         test/ganeti.hooks_unittest.py \
610         test/ganeti.ht_unittest.py \
611         test/ganeti.http_unittest.py \
612         test/ganeti.hypervisor_unittest.py \
613         test/ganeti.hypervisor.hv_chroot_unittest.py \
614         test/ganeti.hypervisor.hv_fake_unittest.py \
615         test/ganeti.hypervisor.hv_kvm_unittest.py \
616         test/ganeti.hypervisor.hv_lxc_unittest.py \
617         test/ganeti.hypervisor.hv_xen_unittest.py \
618         test/ganeti.impexpd_unittest.py \
619         test/ganeti.jqueue_unittest.py \
620         test/ganeti.locking_unittest.py \
621         test/ganeti.luxi_unittest.py \
622         test/ganeti.masterd.instance_unittest.py \
623         test/ganeti.mcpu_unittest.py \
624         test/ganeti.netutils_unittest.py \
625         test/ganeti.objects_unittest.py \
626         test/ganeti.opcodes_unittest.py \
627         test/ganeti.qlang_unittest.py \
628         test/ganeti.query_unittest.py \
629         test/ganeti.rapi.baserlib_unittest.py \
630         test/ganeti.rapi.client_unittest.py \
631         test/ganeti.rapi.resources_unittest.py \
632         test/ganeti.rapi.rlib2_unittest.py \
633         test/ganeti.rpc_unittest.py \
634         test/ganeti.runtime_unittest.py \
635         test/ganeti.serializer_unittest.py \
636         test/ganeti.ssh_unittest.py \
637         test/ganeti.tools.ensure_dirs_unittest.py \
638         test/ganeti.uidpool_unittest.py \
639         test/ganeti.utils.algo_unittest.py \
640         test/ganeti.utils.filelock_unittest.py \
641         test/ganeti.utils.hash_unittest.py \
642         test/ganeti.utils.io_unittest.py \
643         test/ganeti.utils.log_unittest.py \
644         test/ganeti.utils.mlock_unittest.py \
645         test/ganeti.utils.nodesetup_unittest.py \
646         test/ganeti.utils.process_unittest.py \
647         test/ganeti.utils.retry_unittest.py \
648         test/ganeti.utils.text_unittest.py \
649         test/ganeti.utils.wrapper_unittest.py \
650         test/ganeti.utils.x509_unittest.py \
651         test/ganeti.utils_unittest.py \
652         test/ganeti.workerpool_unittest.py \
653         test/cfgupgrade_unittest.py \
654         test/docs_unittest.py \
655         test/tempfile_fork_unittest.py
656
657 haskell_tests = htools/test
658
659 dist_TESTS = \
660         test/check-cert-expired_unittest.bash \
661         test/daemon-util_unittest.bash \
662         test/ganeti-cleaner_unittest.bash \
663         test/import-export_unittest.bash \
664         $(python_tests)
665
666 nodist_TESTS =
667 if WANT_HTOOLS
668 nodist_TESTS += $(haskell_tests)
669 endif
670
671 TESTS = $(dist_TESTS) $(nodist_TESTS)
672
673 # Environment for all tests
674 PLAIN_TESTS_ENVIRONMENT = \
675         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
676
677 # Environment for tests run by automake
678 TESTS_ENVIRONMENT = \
679         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
680
681 all_python_code = \
682         $(dist_sbin_SCRIPTS) \
683         $(dist_tools_SCRIPTS) \
684         $(pkglib_python_scripts) \
685         $(nodist_pkglib_python_scripts) \
686         $(python_tests) \
687         $(pkgpython_PYTHON) \
688         $(client_PYTHON) \
689         $(hypervisor_PYTHON) \
690         $(rapi_PYTHON) \
691         $(server_PYTHON) \
692         $(pytools_PYTHON) \
693         $(http_PYTHON) \
694         $(confd_PYTHON) \
695         $(masterd_PYTHON) \
696         $(impexpd_PYTHON) \
697         $(utils_PYTHON) \
698         $(watcher_PYTHON) \
699         $(noinst_PYTHON) \
700         $(qa_scripts)
701
702 srclink_files = \
703         man/footer.rst \
704         test/check-cert-expired_unittest.bash \
705         test/daemon-util_unittest.bash \
706         test/ganeti-cleaner_unittest.bash \
707         test/import-export_unittest.bash \
708         $(all_python_code) \
709         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
710
711 check_python_code = \
712         $(BUILD_BASH_COMPLETION) \
713         $(DOCPP) \
714         $(all_python_code)
715
716 lint_python_code = \
717         ganeti \
718         ganeti/http/server.py \
719         $(dist_sbin_SCRIPTS) \
720         $(dist_tools_SCRIPTS) \
721         $(pkglib_python_scripts) \
722         $(BUILD_BASH_COMPLETION) \
723         $(DOCPP) \
724         $(PYTHON_BOOTSTRAP)
725
726 test/daemon-util_unittest.bash: daemons/daemon-util
727
728 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
729
730 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
731         sed -f $(REPLACE_VARS_SED) < $< > $@
732         chmod +x $@
733
734 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
735         sed -f $(REPLACE_VARS_SED) < $< > $@
736         chmod u+x $@
737
738 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
739         sed -f $(REPLACE_VARS_SED) < $< > $@
740         chmod +x $@
741
742 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
743         sed -f $(REPLACE_VARS_SED) < $< > $@
744
745 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
746         sed -f $(REPLACE_VARS_SED) < $< > $@
747
748 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
749         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
750         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
751
752 doc/%.png: doc/%.dot
753         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
754         $(DOT) -Tpng -o $@ $<
755
756 man/footer.man: man/footer.rst
757         @test -n "$(PANDOC)" || \
758           { echo 'pandoc' not found during configure; exit 1; }
759         $(PANDOC) -f rst -t man -o $@ $<
760
761 man/footer.html: man/footer.rst
762         @test -n "$(PANDOC)" || \
763           { echo 'pandoc' not found during configure; exit 1; }
764         $(PANDOC) -f rst -t html -o $@ $<
765
766 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
767         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
768
769 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
770         @test -n "$(PANDOC)" || \
771           { echo 'pandoc' not found during configure; exit 1; }
772         set -o pipefail ; \
773         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
774           sed -e 's/\\@/@/g' > $@
775         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
776
777 man/%.html.in: man/%.gen man/footer.html
778         @test -n "$(PANDOC)" || \
779           { echo 'pandoc' not found during configure; exit 1; }
780         set -o pipefail ; \
781         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
782           sed -e 's/\\@/@/g' > $@
783
784 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
785         sed -f $(REPLACE_VARS_SED) < $< > $@
786
787 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
788         sed -f $(REPLACE_VARS_SED) < $< > $@
789
790 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
791         sed -f $(REPLACE_VARS_SED) < $< > $@
792
793 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
794         sed -f $(REPLACE_VARS_SED) < $< > $@
795
796 epydoc.conf: epydoc.conf.in Makefile
797         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
798
799 vcs-version:
800         if test -d .git; then \
801           git describe > $@; \
802         elif test ! -f $@ ; then \
803           echo "Cannot auto-generate $@ file"; exit 1; \
804         fi
805
806 .PHONY: regen-vcs-version
807 regen-vcs-version:
808         set -e; \
809         cd $(srcdir); \
810         if test -d .git; then \
811           rm -f vcs-version; \
812           $(MAKE) vcs-version; \
813         fi
814
815 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
816         set -e; \
817         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
818         sed -e "s/%ver%/$$VCSVER/" < $< > $@
819
820 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
821         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
822         set -e; \
823         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
824
825 lib/_autoconf.py: Makefile vcs-version | lib/.dir
826         set -e; \
827         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
828         { echo '# This file is automatically generated, do not edit!'; \
829           echo '#'; \
830           echo ''; \
831           echo '"""Build-time configuration for Ganeti.'; \
832           echo '';\
833           echo 'This file is autogenerated by the build process.'; \
834           echo 'For any changes you need to re-run ./configure (and'; \
835           echo 'not edit by hand).'; \
836           echo ''; \
837           echo '"""'; \
838           echo ''; \
839           echo '# pylint: disable-msg=C0301,C0324'; \
840           echo '# because this is autogenerated, we do not want'; \
841           echo '# style warnings' ; \
842           echo ''; \
843           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
844           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
845           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
846           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
847           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
848           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
849           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
850           echo "SYSCONFDIR = '$(sysconfdir)'"; \
851           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
852           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
853           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
854           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
855           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
856           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
857           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
858           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
859           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
860           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
861           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
862           echo "KVM_PATH = '$(KVM_PATH)'"; \
863           echo "SOCAT_PATH = '$(SOCAT)'"; \
864           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
865           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
866           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
867           echo "TOOLSDIR = '$(toolsdir)'"; \
868           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
869           echo "PKGLIBDIR = '$(pkglibdir)'"; \
870           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
871           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
872           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
873           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
874           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
875           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
876           echo "RAPI_USER = '$(RAPI_USER)'"; \
877           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
878           echo "CONFD_USER = '$(CONFD_USER)'"; \
879           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
880           echo "NODED_USER = '$(NODED_USER)'"; \
881           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
882           echo "VCS_VERSION = '$$VCSVER'"; \
883           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
884           if [ "$(HTOOLS)" ]; then \
885             echo "HTOOLS = True"; \
886           else \
887             echo "HTOOLS = False"; \
888           fi; \
889         } > $@
890
891 $(REPLACE_VARS_SED): Makefile
892         set -e; \
893         { echo 's#@PREFIX@#$(prefix)#g'; \
894           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
895           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
896           echo 's#@BINDIR@#$(bindir)#g'; \
897           echo 's#@SBINDIR@#$(sbindir)#g'; \
898           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
899           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
900           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
901           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
902           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
903           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
904           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
905           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
906           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
907           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
908           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
909           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
910           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
911           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
912           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
913           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
914           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
915           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
916         } > $@
917
918 # Using deferred evaluation
919 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
920 daemons/ganeti-watcher: MODULE = ganeti.watcher
921 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
922 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
923
924 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
925         test -n "$(MODULE)" || { echo Missing module; exit 1; }
926         set -e; \
927         { echo '#!/usr/bin/python'; \
928           echo '# This file is automatically generated, do not edit!'; \
929           echo "# Edit $(MODULE) instead."; \
930           echo; \
931           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
932           echo; \
933           echo '# pylint: disable-msg=C0103'; \
934           echo '# C0103: Invalid name'; \
935           echo; \
936           echo 'import sys'; \
937           echo 'import $(MODULE) as main'; \
938           echo; \
939           echo '# Temporarily alias commands until bash completion'; \
940           echo '# generator is changed'; \
941           echo 'if hasattr(main, "commands"):'; \
942                 echo '  commands = main.commands # pylint: disable-msg=E1101'; \
943           echo; \
944           echo 'if __name__ == "__main__":'; \
945           echo '  sys.exit(main.Main())'; \
946         } > $@
947         chmod u+x $@
948
949 # We need to create symlinks because "make distcheck" will not install Python
950 # files when building.
951 stamp-srclinks: Makefile | $(all_dirfiles)
952         set -e; \
953         for i in $(srclink_files); do \
954                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
955                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
956                 fi; \
957         done
958         touch $@
959
960 .PHONY: ganeti
961 ganeti:
962         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
963
964 .PHONY: check-dirs
965 check-dirs: $(BUILT_SOURCES)
966         @set -e; \
967         find . -type d \( \( -name . \) -o \( \
968                 -name .git -o \
969                 -name autom4te.cache \
970                 \) -prune -o -print \) | { \
971                 error=; \
972                 while read dir; do \
973                         case "$$dir" in \
974                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
975                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
976                         esac; \
977                 done; \
978                 for dir in $(DIRS); do \
979                         if ! test -d "$$dir"; then \
980                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
981                                 error=1; \
982                         fi \
983                 done; \
984                 if test -n "$$error"; then exit 1; else exit 0; fi; \
985         }
986
987 check-local: check-dirs
988         $(CHECK_PYTHON_CODE) $(check_python_code)
989         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
990         $(CHECK_NEWS) < $(top_srcdir)/NEWS
991         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
992         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
993                 echo "Incorrect version in README, expected $$expver"; \
994                 exit 1; \
995         fi; \
996         if test "`sed -ne '4 p' $(top_srcdir)/doc/iallocator.rst`" != \
997                                         "Documents Ganeti version $$expver"; then \
998                 echo "Incorrect version in iallocator.rst, expected $$expver"; \
999                 exit 1; \
1000         fi
1001
1002 .PHONY: hs-check
1003 hs-check: htools/test
1004         @rm -f test.tix
1005         ./htools/test
1006
1007 .PHONY: lint
1008 lint: $(BUILT_SOURCES)
1009         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1010         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1011         cd $(top_srcdir)/qa && \
1012           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1013           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1014
1015 .PHONY: hlint
1016 hlint: $(HS_BUILT_SRCS)
1017         if tty -s; then C="-c"; else C=""; fi; \
1018         hlint --report=doc/hs-lint.html $$C htools
1019
1020 # a dist hook rule for updating the vcs-version file; this is
1021 # hardcoded due to where it needs to build the file...
1022 dist-hook:
1023         $(MAKE) regen-vcs-version && \
1024         rm -f $(top_distdir)/vcs-version && \
1025         cp -p $(srcdir)/vcs-version $(top_distdir)
1026
1027 # a distcheck hook rule for catching revision control directories
1028 distcheck-hook:
1029         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1030                 echo "Found revision control files in final archive." 1>&2; \
1031                 exit 1; \
1032         fi
1033         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1034                 echo "Found Python byte code in final archive." 1>&2; \
1035                 exit 1; \
1036         fi
1037         if find $(top_distdir) -name '*~' | grep .; then \
1038                 echo "Found backup files in final archive." 1>&2; \
1039                 exit 1; \
1040         fi
1041 # Empty files or directories should not be distributed. They can cause
1042 # unnecessary warnings for packagers. Directories used by automake during
1043 # distcheck must be excluded.
1044         if find $(top_distdir) -empty -and -not \( \
1045                         -path $(top_distdir)/_build -or \
1046                         -path $(top_distdir)/_inst \) | grep .; then \
1047                 echo "Found empty files or directories in final archive." 1>&2; \
1048                 exit 1; \
1049         fi
1050         if test -n "$(BUILD_RELEASE)" && \
1051            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1052                 echo "Found unreleased version in NEWS." >&2; \
1053                 exit 1; \
1054         fi
1055
1056 # When building a release, stricter checks should be used
1057 distcheck-release dist-release: export BUILD_RELEASE = 1
1058 distcheck-release: distcheck
1059
1060 dist-release: dist
1061         set -e; \
1062         for i in $(DIST_ARCHIVES); do \
1063                 echo -n "Checking $$i ... "; \
1064                 autotools/check-tar < $$i; \
1065                 echo OK; \
1066         done
1067
1068 install-exec-local:
1069         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1070           "$(DESTDIR)${localstatedir}/log/ganeti" \
1071           "$(DESTDIR)${localstatedir}/run/ganeti"
1072
1073 # To avoid conflicts between directory names and other targets, a file inside
1074 # the directory is used to ensure its existence.
1075 %.dir:
1076         @mkdir_p@ $* && touch $@
1077
1078 .PHONY: apidoc
1079 if WANT_HTOOLSAPIDOC
1080 apidoc: py-apidoc hs-apidoc
1081 else
1082 apidoc: py-apidoc
1083 endif
1084
1085 .PHONY: py-apidoc
1086 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1087         $(RUN_IN_TEMPDIR) epydoc -v \
1088                 --conf $(CURDIR)/epydoc.conf \
1089                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1090
1091 .PHONY: hs-apidoc
1092 hs-apidoc: $(HS_BUILT_SRCS)
1093         @test -n "$(HSCOLOUR)" || \
1094             { echo 'HsColour' not found during configure; exit 1; }
1095         @test -n "$(HADDOCK)" || \
1096             { echo 'haddock' not found during configure; exit 1; }
1097         rm -rf $(APIDOC_HS_DIR)/*
1098         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools
1099         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1100         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1101         set -e ; \
1102         cd htools; \
1103         if [ "$(HTOOLS_NOCURL)" ]; \
1104         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1105         else OPTGHC=""; \
1106         fi; \
1107         RELSRCS="$(HS_LIB_SRCS:htools/%=%)"; \
1108         for file in $$RELSRCS; do \
1109                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1110                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1111         done ; \
1112         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1113                 -t ganeti-htools -p haddock-prologue \
1114                 --source-module="%{MODULE/.//}.html" \
1115                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1116                 $$OPTGHC \
1117                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1118
1119 .PHONY: TAGS
1120 TAGS: $(BUILT_SOURCES)
1121         rm -f TAGS
1122         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1123           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1124           -path './qa/*.py' | \
1125           etags -l python -
1126
1127 .PHONY: coverage
1128 if WANT_HTOOLS
1129 coverage: py-coverage hs-coverage
1130 else
1131 coverage: py-coverage
1132 endif
1133
1134 .PHONY: py-coverage
1135 py-coverage: $(BUILT_SOURCES) $(python_tests)
1136         set -e; \
1137         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1138         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1139         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1140         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1141         $(python_tests)
1142
1143 .PHONY: hs-coverage
1144 hs-coverage: $(haskell_tests)
1145         cd htools && rm -f *.tix *.mix && ./test
1146         mkdir -p $(COVERAGE_HS_DIR)
1147         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1148         hpc report htools/test $(HPCEXCL)
1149         ln -sf hpc_index.html $(COVERAGE_HS_DIR)/index.html
1150
1151 # Special "kind-of-QA" target for htools, needs special setup (all
1152 # tools compiled with -fhpc)
1153 .PHONY: live-test
1154 live-test: all
1155         set -e ; \
1156         cd htools; \
1157         rm -f .hpc; ln -s ../.hpc .hpc; \
1158         rm -f *.tix *.mix; \
1159         ./live-test.sh; \
1160         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1161           --output=live-test.tix ; \
1162         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1163         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1164                 --srcdir=.. $(HPCEXCL) ; \
1165         hpc report --srcdir=.. live-test $(HPCEXCL)
1166
1167 commit-check: distcheck lint apidoc
1168
1169 -include ./Makefile.local
1170
1171 # vim: set noet :